
Network Assistant: Versions History
===================================

Legend 
~~~~~~
    + new feature, improvement 
    * miscellaneous change, modification
    ! bug fix


Network Assistant v4.1 build 2393 (October 6, 2005)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    + Message board: ability to format text of messages (color/bold/italic/
      underline/alignment) and ability to insert emoticons and external pictures
      into messages
    + Message board: avatars support
    + Message board: ability to collapse/expand single/all messages
    + Message board saves state of all messages (new/updated/collapsed)
    + Added timeout protection for signals to single user
    ! Tray icon did not update. Fixed.
    ! Fixed non-permanent error on "Edit My User Details" command (AV-005297FF)
    ! Message Board: fixed bug with bulb flags (New -> Updated)


Network Assistant v4.0 build 2383 (May 27, 2005)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    + Message board (currently supports centralized messages storage mode only)
    + User details for each user - summary/work/contact/background information
      and picture (photo)
    + Ability to specify your gender (male/female) in your user details
    ! Fixed some serious problems with users list stability
    + Added new protection layer into communication protocol. This improves
      Nassi stability against hacker attacks (packet flood / invalid packets).
    + Ability to disable any primary page/feature of main window: Users list,
      Chat, Whiteboard, Message Board and Event Log
    * Local privacy settings were greatly tightened by default
    + New "Offline" state. All network functionality is disabled in this state.
    * No more "Gaming" state. Also the number of custom states was limited to 6.
    + New state options:
        - Ignore "Important" flag of messages;
        - Disable new announcer chat channels.
    + Up to 12 chat macros. Use [Shift+Ctrl+F1..F12] to assign string
      to a macro and [Shift+F1..F12] to use a macro.
    + Context menus for chat channels and instant messages
    + Four customizable click-on-user shortcuts: (mouse click, [Ctrl]+click, 
      [Alt]+click, [Shift]+click). Setup -> General -> Click-on-user shortcuts.
    + Whiteboard: picture placing improved (JPEG compression in pictures
      placing algorithm)
    + Whiteboard: ability to cancel picture placing (from file/clipboard) by
      [Esc] key
    + Screenshot view: ability to view(grab) foreground window
    + Screenshot view: ability to move selection rectangle
    + Processes view: ability to sort processes list by PID, Module and
      Window title
    + Flood protection: maximum number of smiles per message was limited to 10
    + Author name is added to chat channel topic
    + Added timeout protection for chat topic changes (30 sec)
    + Close chat channels with middle mouse button click
    ! Flood protection operated for invalid (invisible) chat channels. Fixed.
    + Repeatable emoticons support:  :-)))  ->  :-):-):-)
    + Down [Ctrl] key to past an emoticon without closing emoticons picker
    + Main Window: new status bar button "Disable Chat-In-Tip"
    + New Nassi logo, new user/states icons, new tray icons
      (true color / alpha channel)
    + Ability to disable blinking of tray icon
      (Setup -> General -> System tray icon)
    + More informative tray icon tips
    + Setup: new option "Disable event log notifications" (Setup -> General):
      disables event log blinking on important event log messages.
    * Inability to change nickname while in User mode
    + New chat commands: 
        "/me"   - to say something from yourself;
        "/info" - opens user's info (user details, processes, etc...).
    + New command line parameter "/ProgramStartupDeferment=N".
      With this parameter you can delay program startup for N seconds.
    * Miscellaneous GUI enhancements
    ! Fixed several minor bugs
    * Countless internal polishes
    * Network Assistant 4.0 uses new registration codes


Network Assistant v3.2 build 2260 (June 1, 2004)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    + The help system has been updated and converted to Html format (CHM)
    + Russian.lng file has been updated
    ! Fixed several minor bugs


Network Assistant v3.2 beta 4 build 2255 (May 1, 2004)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    + Emoticons support (42 emoticons in MSN Messenger style) in chat and
      instant message window
    + License manager: allows you to register and unregister remote copies
      of Nassi
    + Instant message window: new option "Important message (popup)". When this
      option is set the instant message window will popup on the remote side.
    + Ability to disable autoscrolling of chat text
    + "Ignore all broadcast signals" option (Setup -> Filtration/Blocking)
    * Improved flood protection
    + Flood protection notifications
    + Added timeout protection for consequent repeated chat phrases
    + Added timeout protection for broadcast signals
    + Ability to replace bad words by custom string (e.g. '<censored>')
    + Autocomplete usernames on TAB in chat phrase window
    + Ctrl+Tab[+Shift] switch chat channels in chat phrase window
    + En-Ru text revert (Alt+R) in instant message window
    * Autorefresh users list by timer option removed but the registry setting
      is available at "HKEY_CURRENT_USER\Software\Gracebyte Software\
        Network Assistant\UsersListAutoRefreshInterval (DWORD value in sec)
    + Ability to hide the header bar (Alt+H shortcut)
    + New TCP Port option (Setup -> Connection -> Settings)
    * Format of connection settings file has been slightly changed


Network Assistant v3.2 beta 3 build 2203 (February 1, 2004)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    + Blocked users list: ability to ignore/block activity of some users.
      You can block a user by its nickname, workstation name or workstation
      IP address. There are several blocking rules available for each blocked
      user. See Setup -> Filtration/Blocking -> Users.
    + Flood protection. See Setup -> Filtration/Blocking -> Flood.
    + Seriously improved syntax support for "Bad Words". Now it is possible
      to use wildcards ("*" and "?") and sets ("[...]") in words.
      Refer to help for details.
    + Export/import to file functions for the "Bad Words" list
    + Appeals. You can appeal to any user in the active chat channel via user's
      context menu (new menu command "Appeal In Chat") or by left mouse click
      on the contacts list with Shift key downed.
    + Appeal format can be configured 
      (Setup->Chat or main menu->Chat->Setup Messages)
    + New "Block" and "Appeal In Chat" commands in user context menu
    + New messages filtration options (Setup -> Filtration/Blocking):
        + Ignore Nassi messages (None/Broadcast/All)
        + Ignore Messenger/WinPopup messages (None/Broadcast/All)
        + Ignore my (local) broadcast messages
    + "Pop up main window/On Shortcut Key" option hides active Nassi to tray
    * Security level of alerts tracking improved


Network Assistant v3.2 beta 2 build 2173 (December 31, 2003)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    + Bad Words filtration/censorship.


Network Assistant v3.2 beta 1 build 2160 (November 18, 2003)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    + Startup chat channels - ability to automatically join the desired channels
      (except password channels) at program startup
    + Ability to disable broadcast actions (messages, signal) in admin mode
      (Setup -> Security | Remote Privacy)
    + Automatic and manual detection of new Network Assistant versions
      via Internet
    + Nassi version info in the Comments column of Users List
    + Two new Nassi states: "maximized" and "minimized" in the Comments column
      of Users List
    * New style of information/confirmation/warning/error message window
    ! Fixed serious security bug in the processes view. It was possible to
      control remote processes even if this was disabled on the remote side
      in some cases.
    ! The "Pop up main window on private chat" option used to affect all
      channels but not private only. Fixed.
    ! Problem with Ctrl+X|C|V shortcuts (when used in secondary windows) fixed
    + Miscellaneous cosmetics enhancements


Network Assistant v3.2 beta 0 build 2139 (September 28, 2003)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    + Export/import connection settings to/from a file
    + Ability to load connection settings from external file on startup
    + Setup: "Users list refresh timeout" option
    + Setup: Administraton options (enable/disable/change admin password)
    + Setup: ability to hide system messages in chat
    + Setup: "Show startup splash screen" option (available for registered users
      only)
    + "New password" windows: "Confirm New Password" field added
    * Updated design of the setup window. New categories were added.
    ! "Setup state" window: fixed "garbage" explanation error
    ! Alerts: inability to save some alert properties. Fixed.
    ! Fixed several minor bugs


Network Assistant v3.1 build 2128 (January 2, 2003)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    + Beside Administrator and User modes new "permanent administrator" mode
      added. This is the default mode and it acts until you specify
      administrator password.
    ! Some administrator passwords (like '11') could not be saved. Fixed.
    + Blinking icon on "Next" instant message button
    + Improved mouse wheel support:
        + now it works without losing keyboard focus
        * phrases history scroll works with Ctrl key downed
        + View bar buttons scroll support
    ! Fixed broken "Enabled Chat-In-Tip feature" setup option
    ! Multiple screenshots caused memory leaks and errors (in JPEG mode). Fixed.
    + Whiteboard picture (1000*700) is centered on whiteboard page in very high
      display resolutions
    + Ctrl+N keyboard shortcut for the create new state dialog
    + New keyboard shortcuts for whiteboard:
        "[" / "]" - decreases/increases pen thickness
        Esc - cancels line, rectangle and ellipse tools
    * Chat: Shift+Enter shortcut changed to Alt+Enter (adds phrase to chat and
      minimizes main window to tray)
    * Instant messages: Enter and Ctrl+Enter keyboard shortcuts are exchanged
    ! Fixed several minor bugs


Network Assistant v3.0 build 2110 (October 9, 2002)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ! Fixed serious security related bug. In previous version it was possible
      to override Remote Services setup settings using main toolbar buttons.
    ! Fixed several bugs in instant messaging code.


Network Assistant v3.0 build 2100 (August 20, 2002)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    + Administrator/User mode. Some important settings (like connection
      settings) can not be changed in User mode. Administrator mode is
      protected by password. You can switch to Administrator mode via main menu
      or new command line parameter: "/ADMIN=password".
    + Channel Topic option in Join New Channel dialog
    + Channel topic highlighted (when not empty)
    + Ability to disable chat and/or whiteboard via Setup
    + "Disable Chat-In-Tip" command in tray menu.
    + New command line parameter "/UseMRD" - use Membership Report Delay.
      With this parameter Nassi delays membership answers for other users that
      update their users list to prevent loss of network packets. Useful in big
      networks.
    ! Fixed ridiculous bug that caused default UDP port 50138 to be 56003 in
      fact.
    ! Some bugs of previous beta version fixed


Network Assistant v3.0 beta build 2053 (July 15, 2002)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    + Support for IP Multicast technology that greatly improves
      interoperability in routed environment and allows traffic-friendly group
      messages
    + Encryption of all UDP traffic using Blowfish cipher
    + File transfers between users (resumes are supported)
    Chat:
        + extended channels ideology, added new channels types 
          (announcers and password protected channels)
        + chat history
        + chat commands ("/<command>", see help for detailed description)
        + new tags for formatting messages (including color markers)
        + ability to invite/kick some user to/from some channel
        + ability to signal to some channel
        + ability to open current channel log
        + automatic URL detection and highlighting
    Whiteboard:
        + ability to load and paste images (bmp, jpg, ico, emf, wmf)
        + new tools: line, rectangle, ellipse
        + Snap To Grid mode
        * network usage in pen tool mode was greatly reduced
        + ability to change pen thickness by mouse wheel
        + right mouse click opens color picker
    * All user specific files (configuration file, logs, received files) were
      moved to application-specific data folder of current user
    + GIF compression support for screenshots
    + Ability to disable system/WinPopup messages receipt
    + View Bar
    + Windows XP themes support
    * New color picker
    + Computer name dependant color assigned to chat color at first startup
    + Animation and transparency effects for Chat-In-Tip window
    + New nice splash/About screen
    + Command line parameters (can be combined)
        /safe - Safe mode. On some computers safe mode greatly improves Nassi
                stability but limits some features
        /nonetworkscan - disables automatic network tree scanning on startup
    + Workstation icons in network tree indicate Nassi-enabled workstations
    + All received instant messages minimized
    ! Additional broadcast IP addresses bug (not all IPs could be processed)
    ! Serious bug in communication engine that caused problems on multiple
      interface systems
    * Nassi becomes shareware. No more built-in advertisements


Network Assistant v2.0 build 1745 (December 27, 2000)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ! Fixed compatibility problems with ICQ, Unreal Tournament and other
      software (Windows 9x/Me only)
    ! Fixed chat history bug caused by Windows 9x/Me limitations


Network Assistant v2.0 build 1726 (October 4, 2000)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    + Help system now available
    + Sound Events: PC Speaker support under Windows 95/98
    ! Fixed serious bug in communication code that caused almost all network 
      services unavailable on some systems


Network Assistant v2.0 beta 2 (September 10, 2000)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    + Ability to change/select local IP address
    ! Alerts: fixed invalid behavior of the screen shot taking alert
    ! Whiteboard: fixed the bug of pen tool that drawn unexpected lines
      sometimes
    ! Chat-In-Tip: fixed the bug when Chat-In-Tip window is configured to be
      shown in the top right desktop corner
    ! Fixed "RICHLINE INSERTION ERROR" bug
    * Stack dumping in bug reports made correct
    * Some changes of tray icons behavior


Network Assistant v2.0 beta 1 (July 19, 2000)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    + New connection engine (based on Winsockets instead of Mailslots API)
    + Screenshots taking has been made much more stable and quicker
    * There is not built-in router any more. Instead of old router you can
      specify additional broadcast IP addresses
    + New stylish interface (dockable toolbars and "round" tool buttons)
    + Current-mode-sensitive main menu
    + "Contacts" toolwindow. It lists online users and allows you to select
      recipients quickly
    + New properties for every state: Autoanswer, Message minimization, Sound
      disabling and more
    + Up to 10 user defined (custom) states
    + Up to 10 user defined nicknames (with history)
    + Chat: Channels concept. You can join public channels or talk privately
      with only one remote user (person-to-person). Nassi remembers last 20
      public channels which you had joined. Also you can specify channels which
      you would like to join at startup
    + Chat: You can specify/change the topic of current channel
    + Instant messages. Access to this feature has been made more easy and
      intuitive: single click on a user in the Contacts window opens 
      "Send Message" dialog. Incoming messages from a particular user are
      queued. WinPopup/Messenger messages use the same framework
    + Whiteboard: Pan and Text tools
    + Whiteboard now resides in memory only when it is being used
    * "Special" tab has been renamed to "Special Services". Currently only one
      special service is available: Date/Time Synchronization
    + Event Log tab. Event log records some system messages and errors
    + Logging. From this version Network Assistant stores all chat public
      channels, private channels, instant messages and event log in 
      corresponding text files in the Logs folder (by default)
    + Formattable text output for chat history and Chat-In-Tip
    + "Print" feature for the current chat channel and whiteboard
    + New sound events for joining/leaving channel
    + New "Setup Sound Event" dialog. In addition to playing wave sound you can
      use PC speaker. Moreover you can specify duration, frequency and one of
      five types of sounding (available for Windows NT only)
    + You can view the text content of remote Windows clipboard
    + Multilanguage support. By default, Network Assistant supports English and
      Russian. Additional languages available for download from web site
    * New "Setup" dialog design
    + New setup options:
        - General: Minimize/Close button action
        - General: Pop up main window options
        - General: Run Network Assistant at startup
        - Auto "Away": on Screen saver / monitor power off / StandBy / Suspend
        - Security: Disable clipboard view
        - Security: Disable statistics view
        - New logging options
    + You can specify nonstandard fonts for user interface, chat windows,
      instant messages and Chat-In-Tip
    + Context popup menus for users list and Contacts window
    + New "Floating" feature for the online user
    + Alerts: New alert: On Screenshot taking
    + Alerts: New actions: 
        - Add alert message to event log
        - Automatically send message back
    * "Define Alerts" dialog is sizable now
    + New columns (parameters) in users list: Ping time and IP address
    + New "Setup Columns" dialog allows you to setup columns for users list
    + New Autorefresh Users List options:
        - Autorefresh on program activation
        - Autorefresh on Users List activation
    + New "Setup Refresh Timer" dialog
    + Shortcuts and accelerator keys for most commands
    * Traffic History panel has been redesigned
    + Improved the "Sticky window" feature
    + Improved the behavior of the tray icon
    * "Neighborhoods" tab has been renamed to "Users"
    ! Fixed incorrect Idle Time calculation (when using only keyboard)
    ! Fixed very small unreadable fonts problem
    ! Fixed Network Tree browser code
    ! Fixed several bugs from previous versions


Network Assistant v1.9 (November 2, 1999)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
    The very first public release.


...
Several unreleased versions has been done since version 1.0
...


Network Assistant v1.0
~~~~~~~~~~~~~~~~~~~~~~
    The original version. Very primitive. Unreleased.